## org.apache.mahout.math.matrix.impl
Class AbstractMatrix2D

    java.lang.Object
      org.apache.mahout.math.PersistentObject
          org.apache.mahout.math.matrix.impl.AbstractMatrix
              org.apache.mahout.math.matrix.impl.AbstractMatrix2D

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

Direct Known Subclasses:
  DoubleMatrix2D

Deprecated. until unit tests are in place. Until this time, this class/interface is unsupported.

    @Deprecated
    public abstract class AbstractMatrix2D

extends AbstractMatrix

See Also:
  Serialized Form

Field Summary
`protected int` `columns` Deprecated. the number of colums and rows this matrix (view) has
`protected int` `columnStride` Deprecated. the number of elements between two columns, i.e.
`protected int` `columnZero` Deprecated.
`protected int` `rows` Deprecated.
`protected int` `rowStride` Deprecated. the number of elements between two rows, i.e.
`protected int` `rowZero` Deprecated. the index of the first element

Fields inherited from class org.apache.mahout.math.matrix.impl.AbstractMatrix
`isNoView`

Constructor Summary
`protected` `AbstractMatrix2D()` Deprecated. Makes this class non instantiable, but still let's others inherit from it.

Method Summary
`protected void` `checkBox(int row, int column, int height, int width)` Deprecated. Checks whether the receiver contains the given box and throws an exception, if necessary.
`protected void` `checkColumn(int column)` Deprecated. Sanity check for operations requiring a column index to be within bounds.
`protected void` `checkColumnIndexes(int[] indexes)` Deprecated. Checks whether indexes are legal and throws an exception, if necessary.
`protected void` `checkRow(int row)` Deprecated. Sanity check for operations requiring a row index to be within bounds.
`protected void` `checkRowIndexes(int[] indexes)` Deprecated. Checks whether indexes are legal and throws an exception, if necessary.
`void` `checkShape(AbstractMatrix2D B)` Deprecated. Sanity check for operations requiring two matrices with the same number of columns and rows.
`void` `checkShape(AbstractMatrix2D B, AbstractMatrix2D C)` Deprecated. Sanity check for operations requiring matrices with the same number of columns and rows.
`protected int` `columnOffset(int absRank)` Deprecated. Returns the position of the given absolute rank within the (virtual or non-virtual) internal 1-dimensional array.
`protected int` `columnRank(int rank)` Deprecated. Returns the absolute rank of the given relative rank.
`int` `columns()` Deprecated. Returns the number of columns.
`protected int` `index(int row, int column)` Deprecated. Returns the position of the given coordinate within the (virtual or non-virtual) internal 1-dimensional array.
`protected int` `rowOffset(int absRank)` Deprecated. Returns the position of the given absolute rank within the (virtual or non-virtual) internal 1-dimensional array.
`protected int` `rowRank(int rank)` Deprecated. Returns the absolute rank of the given relative rank.
`int` `rows()` Deprecated. Returns the number of rows.
`protected void` `setUp(int rows, int columns)` Deprecated. Sets up a matrix with a given number of rows and columns.
`protected void` `setUp(int rows, int columns, int rowZero, int columnZero, int rowStride, int columnStride)` Deprecated. Sets up a matrix with a given number of rows and columns and the given strides.
`int` `size()` Deprecated. Returns the number of cells which is `rows()*columns()`.
`protected AbstractMatrix2D` `vColumnFlip()` Deprecated. Self modifying version of viewColumnFlip().
`protected AbstractMatrix2D` `vDice()` Deprecated. Self modifying version of viewDice().
`protected AbstractMatrix2D` `vPart(int row, int column, int height, int width)` Deprecated. Self modifying version of viewPart().
`protected AbstractMatrix2D` `vRowFlip()` Deprecated. Self modifying version of viewRowFlip().
`protected AbstractMatrix2D` `vStrides(int rowStride, int columnStride)` Deprecated. Self modifying version of viewStrides().

Methods inherited from class org.apache.mahout.math.matrix.impl.AbstractMatrix
`ensureCapacity, isView, trimToSize`

Methods inherited from class org.apache.mahout.math.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### columns

    protected int columns

  Deprecated.
  the number of colums and rows this matrix (view) has

### rows

    protected int rows

  Deprecated.

### rowStride

    protected int rowStride

  Deprecated.
  the number of elements between two rows, i.e. `index(i+1,j,k) - index(i,j,k)`.

### columnStride

    protected int columnStride

  Deprecated.
  the number of elements between two columns, i.e. `index(i,j+1,k) - index(i,j,k)`.

### rowZero

    protected int rowZero

  Deprecated.
  the index of the first element

### columnZero

    protected int columnZero

  Deprecated.

Constructor Detail

### AbstractMatrix2D

    protected AbstractMatrix2D()

  Deprecated.
  Makes this class non instantiable, but still let's others inherit from it.

Method Detail

### columnOffset

    protected int columnOffset(int absRank)

  Deprecated.
  Returns the position of the given absolute rank within the (virtual or non-virtual) internal 1-dimensional array. Default implementation. Override, if necessary.

  Parameters:
    `absRank` - the absolute rank of the element.
  Returns:
    the position.

### columnRank

    protected int columnRank(int rank)

  Deprecated.
  Returns the absolute rank of the given relative rank.

  Parameters:
    `rank` - the relative rank of the element.
  Returns:
    the absolute rank of the element.

### rowOffset

    protected int rowOffset(int absRank)

  Deprecated.
  Returns the position of the given absolute rank within the (virtual or non-virtual) internal 1-dimensional array. Default implementation. Override, if necessary.

  Parameters:
    `absRank` - the absolute rank of the element.
  Returns:
    the position.

### rowRank

    protected int rowRank(int rank)

  Deprecated.
  Returns the absolute rank of the given relative rank.

  Parameters:
    `rank` - the relative rank of the element.
  Returns:
    the absolute rank of the element.

### checkBox

    protected void checkBox(int row,
                            int column,
                            int height,
                            int width)

  Deprecated.
  Checks whether the receiver contains the given box and throws an exception, if necessary.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `column<0 || width<0 || column+width>columns() || row<0 || height<0 || row+height>rows()`

### checkColumn

    protected void checkColumn(int column)

  Deprecated.
  Sanity check for operations requiring a column index to be within bounds.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `column < 0 || column >= columns()`.

### checkColumnIndexes

    protected void checkColumnIndexes(int[] indexes)

  Deprecated.
  Checks whether indexes are legal and throws an exception, if necessary.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `! (0 <= indexes[i] < columns())` for any i=0..indexes.length()-1.

### checkRow

    protected void checkRow(int row)

  Deprecated.
  Sanity check for operations requiring a row index to be within bounds.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `row < 0 || row >= rows()`.

### checkRowIndexes

    protected void checkRowIndexes(int[] indexes)

  Deprecated.
  Checks whether indexes are legal and throws an exception, if necessary.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `! (0 <= indexes[i] < rows())` for any i=0..indexes.length()-1.

### checkShape

    public void checkShape(AbstractMatrix2D B)

  Deprecated.
  Sanity check for operations requiring two matrices with the same number of columns and rows.

  Throws:
    `java.lang.IllegalArgumentException` - if `columns() != B.columns() || rows() != B.rows()`.

### checkShape

    public void checkShape(AbstractMatrix2D B,
                           AbstractMatrix2D C)

  Deprecated.
  Sanity check for operations requiring matrices with the same number of columns and rows.

  Throws:
    `java.lang.IllegalArgumentException` - if `columns() != B.columns() || rows() != B.rows() || columns() != C.columns() || rows() != C.rows()`.

### columns

    public int columns()

  Deprecated.
  Returns the number of columns.

### index

    protected int index(int row,
                        int column)

  Deprecated.
  Returns the position of the given coordinate within the (virtual or non-virtual) internal 1-dimensional array.

  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.

### rows

    public int rows()

  Deprecated.
  Returns the number of rows.

### setUp

    protected void setUp(int rows,
                         int columns)

  Deprecated.
  Sets up a matrix with a given number of rows and columns.

  Parameters:
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Throws:
    `java.lang.IllegalArgumentException` - if `rows<0 || columns<0 || (double)columns*rows > Integer.MAX_VALUE`.

### setUp

    protected void setUp(int rows,
                         int columns,
                         int rowZero,
                         int columnZero,
                         int rowStride,
                         int columnStride)

  Deprecated.
  Sets up a matrix with a given number of rows and columns and the given strides.

  Parameters:
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
    `rowZero` - the position of the first element.
    `columnZero` - the position of the first element.
    `rowStride` - the number of elements between two rows, i.e. `index(i+1,j)-index(i,j)`.
    `columnStride` - the number of elements between two columns, i.e. `index(i,j+1)-index(i,j)`.
  Throws:
    `java.lang.IllegalArgumentException` - if `rows<0 || columns<0 || (double)columns*rows > Integer.MAX_VALUE` or flip's are illegal.

### size

    public int size()

  Deprecated.
  Returns the number of cells which is `rows()*columns()`.

  Specified by:
    `size` in class `AbstractMatrix`

### vColumnFlip

    protected AbstractMatrix2D vColumnFlip()

  Deprecated.
  Self modifying version of viewColumnFlip().

### vDice

    protected AbstractMatrix2D vDice()

  Deprecated.
  Self modifying version of viewDice().

### vPart

    protected AbstractMatrix2D vPart(int row,
                                     int column,
                                     int height,
                                     int width)

  Deprecated.
  Self modifying version of viewPart().

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `column<0 || width<0 || column+width>columns() || row<0 || height<0 || row+height>rows()`

### vRowFlip

    protected AbstractMatrix2D vRowFlip()

  Deprecated.
  Self modifying version of viewRowFlip().

### vStrides

    protected AbstractMatrix2D vStrides(int rowStride,
                                        int columnStride)

  Deprecated.
  Self modifying version of viewStrides().

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `rowStride<=0 || columnStride<=0`.

Copyright © 2008-2010 The Apache Software Foundation. All Rights Reserved.